#ifndef EVAL_H
#define EVAL_H

#include "position.h"

extern int WeightMaterial;
extern int WeightPSQ;
extern int WeightMobility;
extern int WeightKingSafety;
extern int WeightPawns;
extern int WeightPassedPawns;

const EVAL INFINITY_SCORE  = 50000;
const EVAL CHECKMATE_SCORE = 32767;
const EVAL DRAW_SCORE      = 0;

const EVAL VAL_PAWN    = 100;
const EVAL VAL_KNIGHT  = 400;
const EVAL VAL_BISHOP  = 400;
const EVAL VAL_ROOK    = 600;
const EVAL VAL_QUEEN   = 1200;
const EVAL BISHOP_PAIR = 20;

static const EVAL VALUE[14] =
{
	0, 0,
	VAL_PAWN, VAL_PAWN,
	VAL_KNIGHT, VAL_KNIGHT,
	VAL_BISHOP, VAL_BISHOP,
	VAL_ROOK, VAL_ROOK,
	VAL_QUEEN, VAL_QUEEN,
	0, 0
};

struct PawnHashEntry
{
	U32 m_hash;
	U64 m_passed;
	U64 m_attackedBy[2];
	int m_ranks[2][10];
	EVAL m_score;

	void Read(const Position& pos);
};

extern PawnHashEntry* g_pawn_hash;
extern long g_pawn_hash_size;

EVAL Evaluate(const Position& pos, EVAL alpha, EVAL beta);
void InitEval();

#endif
